Description

Basically, if you try to set a client's gravity in the on_match of a tag, it will work if the tag is in the first view, but doesn't work in the
other views. To see what | mean... try this config:

http://pastebin.com/MzEfQPEP

Now, what this does is, puts all the terminals on the foo tag and Firefox on the bar tag (adjust it as needed). And then, when the
clients match, it will manually assign them gravities by using on_match.

This works correctly on the foo view (all the terminals are on the left side), but does not work for the bar view (Firefox is not on the
right side as expected).

In addition, it spews out these error messages on the console:

<WARNING> StandardError: No geometry given

from /mnt/pauan/.config/subtle/subtle.rb:49:in ‘gravity'

from /mnt/pauan/.config/subtle/subtle.rb:49:in “block (2 levels) in <main>'
from -e:in “call'

<WARNING> StandardError: No geometry given
from /mnt/pauan/.config/subtle/subtle.rb:40:in “gravity'
from /mnt/pauan/.config/subtle/subtle.rb:40:in “block (2 levels) in <main>'

So, the two bugs are:

1. Complaining about a lack of geometry when setting the gravity of the client
2. Setting the gravity of a client only works on the first view (possibly related to the above bug?)

History

#1 - 05/29/2012 03:41 PM - Christoph Kappel

Without having a glance at your config, you cannot set a gravity with #gravity for any view that is not the current view when you don't use the hash
notation. Read here

#2 - 05/29/2012 05:01 PM - Sae Hirak
Ah! | see! Thank you, | should be able to fix that, then...

#3 - 05/29/2012 05:07 PM - Sae Hirak

Okay, | updated the config and tried both {:foo => :foo} and {"foo" => :foo}. Neither worked, and I'm still getting the No geometry given error, except
this time the error is from accessing c.gravity rather than from setting it.

#4 - 05/29/2012 07:39 PM - Sae Hirak

Okay... | just tried something. | inserted the actual View object rather than a symbol or string:
c.views.each { |v| c.gravity = { v => :foo } }

Now it works. So it seems that you have to use the actual View object itself, you can't use a symbol or string.

#5 - 05/29/2012 08:21 PM - Sae Hirak

Okay... so it seems that when a tag's on_match is called when a client is created, the client has not yet been assigned to a view yet. Is there a reason
for this?
http://pastebin.com/MzEfQPEP
https://subtle.de/projects/subtle/wiki/Gravity
https://subtle.de/projects/subtle/wiki/Views
https://subtle.de/projects/subtle/wiki/Views
http://rdoc.subforge.org/subtle/classes/Subtlext/Client.html#M000072

It seems to me it would be much preferable to run the tag's on_match at about the same time as the :client_create event. That is, after everything
(gravities, view, etc.) has been set up.

#6 - 05/29/2012 09:22 PM - Christoph Kappel

- Category set to Bugfix

- Status changed from Unconfirmed to Confirmed
- Assignee set to Non member users

- Target version set to Xi

| see the problem now, subtle cannot use the means of subtlext to create e.g. the client object, because it cannot be accurate at that point. Therefore
subtle manually creates the objects. r3210 includes proper tagging information now, geometry and gravity are still missing, because | cannot add it
that easily.

The reason for that is the roundtrip that is required to pass information to the X-server and to fetch the information in a single-thread process. | use
some tricks to make it still possible, but it isn't perfect as you can see.

#7 - 06/15/2012 07:29 PM - Christoph Kappel

- Target version changed from Xi to Omicron

#8 - 12/24/2017 07:49 PM - Christoph Kappel

- Target version deleted (Omicron)
